--[[
    LFDAutoJoin by Zenh
    Automatically join ready LFDs.

    Official updates and support page:
    http://www.wowinterface.com/downloads/info15767-LFDAutoJoin.html

    ready.mp3 credits:
    http://www.freesound.org/samplesViewSingle.php?id=18075
]]

----------------------
-- CONFIGURATION START
----------------------

local showAfkMessage = true
local playSound = 2 -- VALUES: false, 1 = Yes, 2 = Only When AFK

local afkMessages = {
    "I'll be ready soon, just need a sec.",
    "Be right there guys, need a sec.",
    "Hey all, I'll be ready in just a bit.",
    "Hi, need a sec to be ready.",
    "Hey, I just need a sec to begin.",
    "Hello, I'll be ready in a sec."
}

local soundFile = 'Interface\\AddOns\\LFDAutoJoin\\ready.mp3'

--------------------
-- CONFIGURATION END
--------------------

if enabled == nil then
    enabled = true
end

local LFDAutoJoin = CreateFrame('Frame', nil, UIParent)

SLASH_LFDAUTOJOIN1 = '/lfdauto'

function SlashCmdList.LFDAUTOJOIN(msg, editbox)
    if enabled then
        enabled = false
        print(' -> LFDAutoJoin: DISABLED')
    else
        enabled = true
        print(' -> LFDAutoJoin: ENABLED')
    end
end

LFDAutoJoin:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
LFDAutoJoin:RegisterEvent('LFG_PROPOSAL_SHOW')
LFDAutoJoin:RegisterEvent('ZONE_CHANGED_NEW_AREA')
LFDAutoJoin:RegisterEvent('PLAYER_FLAGS_CHANGED')

local isAfk = nil

function LFDAutoJoin:LFG_PROPOSAL_SHOW()
    if not enabled then
        return
    end

    if showAfkMessage then
        isAfk = UnitIsAFK('player')
    end

    if playSound == 1 or (playSound == 2 and UnitIsAFK('player')) then
        PlaySoundFile(soundFile)
    end

    LFDDungeonReadyDialogEnterDungeonButton:Click()
end

function LFDAutoJoin:ZONE_CHANGED_NEW_AREA()
    if isAfk then
        isAfk = nil

        local chatType = 'say'

        if IsPartyLFG() and IsInLFGDungeon() then
            chatType = 'party'
        end

        SendChatMessage(afkMessages[random(1, #afkMessages)], chatType)
    end
end

function LFDAutoJoin:PLAYER_FLAGS_CHANGED()
    if arg1 == 'player' and not UnitIsAFK('player') then
        isAfk = nil
    end
end